Unit AET2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02C_p, UTAE12_p;

procedure AET2C(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var HR :Array of Real;
                var HI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var IERR :Integer);

implementation

procedure AET2C(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var HR :Array of Real;
                var HI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var IERR :Integer);
var
EN,ENM1,I,II,ITS,J,L,LL,LP1 :Integer;
BC2,BR2,F,F1,F2,F3,MACHEP,NORM,NORM1,SI,SR,TI,TR,XI,XI1,XR,XR1,YI,YR,
   ZZI,ZZR :Real;
CZ :Complex;
const
SYS056 :Real = 1.175495E-38;
SYS052 :Real = 1.1920928E-7;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250;
begin
{      SYS056 = SYS055 }
MACHEP := SYS052;
IERR := 0;
if ( LOW =  IGH ) 
 then goto _40;
L := LOW + 1;
for I:=L to IGH do
 begin
  LL := Min0(I+1,IGH);
  if ( HI[(I-1)+(I-2)*NM] =  0.00 ) 
   then goto _30;
  NORM := Cabs(Cmplx(HR[(I-1)+(I-2)*NM],HI[(I-1)+(I-2)*NM]));
  YR := HR[(I-1)+(I-2)*NM]/NORM;
  YI := HI[(I-1)+(I-2)*NM]/NORM;
  HR[(I-1)+(I-2)*NM] := NORM;
  HI[(I-1)+(I-2)*NM] := 0.00;
  for J:=I to IGH do
   begin
    SI := YR*HI[(I-1)+(J-1)*NM] - YI*HR[(I-1)+(J-1)*NM];
    HR[(I-1)+(J-1)*NM] := YR*HR[(I-1)+(J-1)*NM] + YI*HI[(I-1)+(J-1)*NM];
    HI[(I-1)+(J-1)*NM] := SI;
_10:
   end;
  for J:=LOW to LL do
   begin
    SI := YR*HI[(J-1)+(I-1)*NM] + YI*HR[(J-1)+(I-1)*NM];
    HR[(J-1)+(I-1)*NM] := YR*HR[(J-1)+(I-1)*NM] - YI*HI[(J-1)+(I-1)*NM];
    HI[(J-1)+(I-1)*NM] := SI;
_20:
   end;
_30:
 end;
_40:
for I:=1 to N do
 begin
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _50;
  WR[I-1] := HR[(I-1)+(I-1)*NM];
  WI[I-1] := HI[(I-1)+(I-1)*NM];
_50:
 end;
EN := IGH;
TR := 0.00;
TI := 0.00;
NORM1 := 0.00;
II := LOW;
for I:=LOW to IGH do
 begin
  for J:=II to IGH do
   begin
    NORM1 := NORM1 + Abs(HR[(I-1)+(J-1)*NM]) + Abs(HI[(I-1)+(J-1)*NM]);
_60:
   end;
  II := I;
_70:
 end;
_80:
if ( EN <  LOW ) 
 then goto _250;
ITS := 0;
ENM1 := EN - 1;
_90:
for LL:=LOW to EN do
 begin
  L := EN + LOW - LL;
  if ( L =  LOW ) 
   then goto _110;
  F := Abs(HR[(L-2)+(L-2)*NM]) + Abs(HI[(L-2)+(L-2)*NM]) + Abs(HR[(L-1)+(L-1)*NM])
    + Abs(HI[(L-1)+(L-1)*NM]);
  if ( ITS >=  5 ) 
   then F := NORM1;
  if ( Abs(HR[(L-1)+(L-2)*NM]) <=  F*MACHEP ) 
   then goto _110;
_100:
 end;
_110:
if ( L =  EN )
 then goto _230;
if ( ITS =  30 ) 
 then goto _240;
if ( ITS =  10 ) or (  ITS =  20 ) 
 then goto _130;
SR := HR[(EN-1)+(EN-1)*NM];
SI := HI[(EN-1)+(EN-1)*NM];
F := EMax1(EMax1(EMax1(Abs(SR),Abs(SI)),Abs(HR[(ENM1-1)+(ENM1-1)*NM])),
    Abs(HI[(ENM1-1)+(ENM1-1)*NM]));
F := EMax1(EMax1(EMax1(F,Abs(HR[(EN-1)+(ENM1-1)*NM])),Abs(HR[(ENM1-1)+(EN-1)*NM])),
    Abs(HI[(ENM1-1)+(EN-1)*NM]));
if ( F <=  SYS056 ) 
 then goto _140;
XR := (HR[(ENM1-1)+(EN-1)*NM]/F)*(HR[(EN-1)+(ENM1-1)*NM]/F);
XI := (HI[(ENM1-1)+(EN-1)*NM]/F)*(HR[(EN-1)+(ENM1-1)*NM]/F);
if ( XR =  0.00 ) and (  XI =  0.00 ) 
 then goto _140;
YR := (HR[(ENM1-1)+(ENM1-1)*NM] - SR)/(2.00*F);
YI := (HI[(ENM1-1)+(ENM1-1)*NM] - SI)/(2.00*F);
XR1 := IntPower(YR,2) - IntPower(YI,2) + XR;
XI1 := 2.0*YR*YI + XI;
CZ := Csqrt(Cmplx(XR1,XI1));
ZZR := Creal(CZ);
ZZI := Aimag(CZ);
if ( YR*ZZR + YI*ZZI >=  0.00 ) 
 then goto _120;
ZZR := -ZZR;
ZZI := -ZZI;
_120:
BR2 := YR + ZZR;
BC2 := YI + ZZI;
AA02C(XR,XI,BR2,BC2,F1,F2);
SR := SR - F1*F;
SI := SI - F2*F;
goto _140;
_130:
SR := Abs(HR[(EN-1)+(ENM1-1)*NM]) + Abs(HR[(ENM1-1)+(EN-3)*NM]);
SI := 0.00;
_140:
for I:=LOW to EN do
 begin
  HR[(I-1)+(I-1)*NM] := HR[(I-1)+(I-1)*NM] - SR;
  HI[(I-1)+(I-1)*NM] := HI[(I-1)+(I-1)*NM] - SI;
_150:
 end;
TR := TR + SR;
TI := TI + SI;
ITS := ITS + 1;
LP1 := L + 1;
for I:=LP1 to EN do
 begin
  SR := HR[(I-1)+(I-2)*NM];
  HR[(I-1)+(I-2)*NM] := 0.00;
  F1 := Abs(HR[(I-2)+(I-2)*NM]);
  F2 := Abs(HI[(I-2)+(I-2)*NM]);
  F3 := Abs(SR);
  F := EMax1(EMax1(F1,F2),F3);
  F1 := F1/F;
  F2 := F2/F;
  F3 := F3/F;
  NORM := F*Sqrt(F1*F1+F2*F2+F3*F3);
  XR := HR[(I-2)+(I-2)*NM]/NORM;
  WR[I-2] := XR;
  XI := HI[(I-2)+(I-2)*NM]/NORM;
  WI[I-2] := XI;
  HR[(I-2)+(I-2)*NM] := NORM;
  HI[(I-2)+(I-2)*NM] := 0.00;
  HI[(I-1)+(I-2)*NM] := SR/NORM;
  for J:=I to N do
   begin
    YR := HR[(I-2)+(J-1)*NM];
    YI := HI[(I-2)+(J-1)*NM];
    ZZR := HR[(I-1)+(J-1)*NM];
    ZZI := HI[(I-1)+(J-1)*NM];
    HR[(I-2)+(J-1)*NM] := XR*YR + XI*YI + HI[(I-1)+(I-2)*NM]*ZZR;
    HI[(I-2)+(J-1)*NM] := XR*YI - XI*YR + HI[(I-1)+(I-2)*NM]*ZZI;
    HR[(I-1)+(J-1)*NM] := XR*ZZR - XI*ZZI - HI[(I-1)+(I-2)*NM]*YR;
    HI[(I-1)+(J-1)*NM] := XR*ZZI + XI*ZZR - HI[(I-1)+(I-2)*NM]*YI;
_160:
   end;
_170:
 end;
SI := HI[(EN-1)+(EN-1)*NM];
if ( SI =  0.00 ) 
 then goto _180;
NORM := Cabs(Cmplx(HR[(EN-1)+(EN-1)*NM],SI));
SR := HR[(EN-1)+(EN-1)*NM]/NORM;
SI := SI/NORM;
HR[(EN-1)+(EN-1)*NM] := NORM;
HI[(EN-1)+(EN-1)*NM] := 0.00;
_180:
for J:=LP1 to EN do
 begin
  XR := WR[J-2];
  XI := WI[J-2];
  for I:=L to J do
   begin
    YR := HR[(I-1)+(J-2)*NM];
    YI := 0.00;
    ZZR := HR[(I-1)+(J-1)*NM];
    ZZI := HI[(I-1)+(J-1)*NM];
    if ( I =  J ) 
     then goto _190;
    YI := HI[(I-1)+(J-2)*NM];
    HI[(I-1)+(J-2)*NM] := XR*YI + XI*YR + HI[(J-1)+(J-2)*NM]*ZZI;
_190:
    HR[(I-1)+(J-2)*NM] := XR*YR - XI*YI + HI[(J-1)+(J-2)*NM]*ZZR;
    HR[(I-1)+(J-1)*NM] := XR*ZZR + XI*ZZI - HI[(J-1)+(J-2)*NM]*YR;
    HI[(I-1)+(J-1)*NM] := XR*ZZI - XI*ZZR - HI[(J-1)+(J-2)*NM]*YI;
_200:
   end;
_210:
 end;
if ( SI =  0.00 ) 
 then goto _90;
for I:=L to EN do
 begin
  YR := HR[(I-1)+(EN-1)*NM];
  YI := HI[(I-1)+(EN-1)*NM];
  HR[(I-1)+(EN-1)*NM] := SR*YR - SI*YI;
  HI[(I-1)+(EN-1)*NM] := SR*YI + SI*YR;
_220:
 end;
goto _90;
_230:
WR[EN-1] := HR[(EN-1)+(EN-1)*NM] + TR;
WI[EN-1] := HI[(EN-1)+(EN-1)*NM] + TI;
EN := ENM1;
goto _80;
_240:
IERR := EN;
_250:
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,5);
end;

end.
